package com.perforce.p4simulink.workspace;

/**
 * Perforce SCM Integration
 */

import com.mathworks.cmlink.api.FileState;
import com.mathworks.cmlink.api.IntegerRevision;
import com.mathworks.cmlink.api.LocalStatus;
import com.mathworks.cmlink.api.Revision;

import java.util.Map;

public class P4FileState implements FileState {

    private static final String WORK_REV_KEY = "workRev";
    private static final String ACTION_KEY = "action";

    Revision revision;
    LocalStatus localStatus;
    boolean hasLock;

    public P4FileState() {
        revision = null;
        localStatus = LocalStatus.NOT_UNDER_CM;
        hasLock = false;
    }

    P4FileState(Map<String, Object> entry) {
        String rev = (String) entry.get(WORK_REV_KEY);
        revision = new IntegerRevision(Integer.valueOf(rev));
        hasLock = false;
        setLocalStatus((String) entry.get(ACTION_KEY));
    }

    @Override
    public Revision getRevision() {
        return null;
    }

    @Override
    public LocalStatus getLocalStatus() {
        return null;
    }

    private void setLocalStatus(String action) {
        switch (action) {
            case "add":
                localStatus = LocalStatus.NOT_UNDER_CM;
                break;
            default:
                localStatus = LocalStatus.UNMODIFIED;
                break;
        }
    }

    @Override
    public boolean hasLock() {
        return hasLock;
    }

    @Override
    public String toString() {
        return "Revision: " + revision.toString() + "\n" +
               "LocalStatus: " + localStatus.toString() + "\n" +
               "HasLock: " + hasLock + "\n";
    }
}
